#define MEMSIZE 0xAAE80
#include "..\lib\kolibri.h" 
#include "..\lib\mem.h" 
#include "..\lib\strings.h" 
#include "..\lib\file_system.h"
#include "..\lib\dll.h"

#include "..\lib\obj\box_lib.h"
#include "..\lib\gui.h"
#include "..\lib\encoding.h"
#include "..\lib\list_box.h"

#ifndef AUTOBUILD
	#include "lang.h--"
#endif

#ifdef LANG_RUS
	#define T_WINDOW_CAPTION "Notes and tasks"
	#define ERROR_1 "Žè¨¡ª  ¯à¨ § £àã§ª¥ ¡¨¡«¨®â¥ª¨ /rd/1/lib/box_lib.obj"
#else
	#define T_WINDOW_CAPTION "Notes and tasks"
	#define ERROR_1 "Error while loading library /rd/1/lib/box_lib.obj"
#endif

#define RED_LINE_W 22
#define COL_BG_ACTIVE 0xFFE56B
#define COL_BG_INACTIVE 0xFFFFFF
#define COL_RED_LINE 0xF3C9C9
unsigned char checkbox[sizeof(file "checkbox.raw")]= FROM "checkbox.raw";
unsigned char edge[sizeof(file "edge.raw")]= FROM "edge.raw"; //292x6
#define CHECKBOX_SIZE 12
#define EDGE_H 6
#define TITLE_H 24
#define HEADER_HEIGHT TITLE_H+EDGE_H
mouse m;

#include "KNotes.h"
#include "KCloseButton.h"
#include "KDeleteButton.h"
KNotes noter;

char editbox_text[256];
proc_info Form;
system_colors sc;
dword mouse_dd;
edit_box edit_box= {200,0,5000,COL_BG_ACTIVE,0x94AECE,COL_BG_ACTIVE,0xffffff,0,248,#editbox_text,#mouse_dd,100000000000010b};
dword lists[] = { 0xEAEAEA, 0xCDCDCD, 0xF0F0F0, 0xD8D8D8, 0 };


void CloseApp()
{
	noter.SaveTxt(0);
	ExitProcess();
}


void main()
{   
	int id, key;
	dword cur_line_offset;
	mouse mn;
	mem_Init();
	if (param) 
	{
		noter.OpenTxt(#param);
	}
	else
	{
		noter.OpenTxt(abspath("notes.txt"));
	}
	noter.list.current = -1;

	if (load_dll2(boxlib, #box_lib_init,0)!=0) notify(ERROR_1);
	SetEventMask(0x27);

	loop()
	{
	  switch(WaitEvent())
	  {
		case evMouse:
			IF (GetProcessSlot(Form.ID)-GetActiveProcess()!=0) break;
			m.get();

			//close button
			if (m.lkm) KCloseButton.ShowClick();

			//select node
			if (m.lkm) || (m.pkm)
			if (m.x>noter.list.x+RED_LINE_W) && (m.x<noter.list.x+noter.list.w) 
			&& (m.y>noter.list.y) && (m.y<noter.list.y+noter.list.h)
			{
				id = m.y-noter.list.y/noter.list.line_h;
				if (KDeleteButton.active) && (m.x>noter.list.x+noter.list.w-KDeleteButton.width) break;
				if (id!=noter.list.current) && (id<noter.list.count) ActivateLine(id);
				else { noter.list.current=-1; noter.DrawList(); }
			}

			//delete button
			if (m.pkm) && (noter.list.current>=0)
			{
				noter.DrawLine(noter.list.current, noter.list.line_h);
				KDeleteButton.Draw(noter.list.x+noter.list.w, noter.list.current*noter.list.line_h+noter.list.y, noter.list.line_h);
				edit_box.top=-20;
				KDeleteButton.active = 1;
				break;
			}

			//drag window - emulate windows header
			if (m.lkm) && (m.y<TITLE_H) && (m.x<Form.width-30)
			{
				do {
					mn.get();
					if (mn.x!=m.x) || (mn.y!=m.y) 
					{
						MoveSize(Form.left+mn.x-m.x, Form.top+mn.y-m.y, OLD, OLD);
						DrawWindow();
					}
					pause(3);
				} while (mn.lkm);
			}

			//editbox
			if (noter.list.current>=0) edit_box_mouse stdcall (#edit_box);
			break;

		 case evButton:
			id=GetButtonID();               
			if (id==1) CloseApp();
			if (id==DELETE_ID)
			{
				noter.DeleteCurrentNode();
				noter.DrawList();
				KDeleteButton.active = 0;
			}
			//checkboxes
			if (id>=500)
			{
				id-=500;
				cur_line_offset = noter.GetLineBufOffset(id)-2;
				if (ESBYTE[cur_line_offset]=='+') ESBYTE[cur_line_offset]='-'; else ESBYTE[cur_line_offset]='+';
				noter.DrawLine(id, noter.list.line_h);
				break;
			}
			break;
	 
		case evKey:
			key = GetKey();
			if (key==027) CloseApp();
			if (key==013) || (key==177) ActivateLine(noter.list.current+1);
			if (key==178) ActivateLine(noter.list.current-1);
			EAX=key<<8;
			if (noter.list.current>=0) edit_box_key stdcall (#edit_box);
			break;
		 
		 case evReDraw:
		 	DrawWindow();
	  }
   }
}



void DrawWindow()
{
	int i;
	noter.list.SetSizes(1, HEADER_HEIGHT, 270, RED_LINE_W*13, 60, RED_LINE_W);
	DefineAndDrawWindow(100,100,noter.list.w+1,noter.list.h+HEADER_HEIGHT+4,0x01,0,0,0x01fffFFF);
	GetProcessInfo(#Form, SelfInfo);
	DrawRectangle3D(0,0,Form.width,TITLE_H-1,0xBB6535, 0xCD6F3B);
	DrawRectangle3D(1,1,Form.width-2,TITLE_H-3,0xEFBFA4, 0xDD8452);
	DrawBar(2,2,Form.width-3,TITLE_H-4,0xE08C5E);
	WriteText(9,TITLE_H/2-2,0x90,0xA9613A,"Notes");
	WriteTextB(7,TITLE_H/2-3,0x90,0xFFFfff,"Notes");
	_PutImage(1, TITLE_H, 292,EDGE_H, #checkbox);
	PutPixel(noter.list.x+RED_LINE_W, noter.list.y-1, COL_RED_LINE);
	ECX-=1;	$int 0x40;
	KCloseButton.Draw(Form.width-23,4,16,16);
	DrawRectangle(0,TITLE_H,Form.width,Form.height-HEADER_HEIGHT+EDGE_H,0xBBBBBB);
	for (i=0; lists[i]!=0; i++) DrawBar(1,Form.height-i-1, Form.width-1, 1, lists[i]);
	edit_box.width = noter.list.w-RED_LINE_W-8;
	edit_box.left = noter.list.x+RED_LINE_W+4;
	noter.DrawList();
}

void DrawEditBox()
{
	edit_box.pos = edit_box.offset = edit_box.shift = 0;
	edit_box.size = strlen(#editbox_text);
	edit_box.top = noter.list.current*noter.list.line_h+3+noter.list.y;
	edit_box_draw stdcall(#edit_box);	
}

void ActivateLine(int line_n)
{
	int old, cur_line_text;
	if (line_n<0) || (line_n>noter.list.count-1) return;
	KDeleteButton.active = 0;
	//redraw lines
	old = noter.list.current;
	noter.list.current = line_n;
	noter.DrawLine(old,                noter.list.line_h);
	cur_line_text = noter.DrawLine(noter.list.current, noter.list.line_h);
	//draw editbox
	strcpy(#editbox_text, cur_line_text+2);
	DrawEditBox();
}




stop:
